/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * ProtectMode defines if the floor should be protected inside a Region
 */
@Getter
@AllArgsConstructor
public enum ProtectMode implements Flag.Value<ProtectMode> {

    ACTIVE("FLAG_PROTECT_ACTIVE"),
    INACTIVE("FLAG_PROTECT_INACTIVE");

    private static ProtectMode[] values;
    private final String chatValue;

    @Override
    public ProtectMode[] getValues() {
        if (ProtectMode.values == null) {
            ProtectMode.values = ProtectMode.values();
        }
        return ProtectMode.values;
    }

    @Override
    public ProtectMode getValue() {
        return this;
    }

    @Override
    public ProtectMode getValueOf(final String name) {
        try {
            return ProtectMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            if (name.equalsIgnoreCase("false")) {
                return ProtectMode.INACTIVE;
            }
            return ProtectMode.ACTIVE;
        }
    }
}
